// ColorSpace.cpp: CColorSpace NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "padie.h"
#include "ColorSpace.h"
#include <math.h>
#include <FLOAT.H>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CColorSpace::CColorSpace()
{

}

CColorSpace::~CColorSpace()
{

}

//---------------------------------------------------------------------------
void CColorSpace::makeMatrixsub(MRX *M, MRX *N)
{
	MRX a;

	a.m11=N->m11*M->m11+N->m12*M->m21, a.m12=N->m11*M->m12+N->m12*M->m22;
	a.m21=N->m21*M->m11+N->m22*M->m21, a.m22=N->m21*M->m12+N->m22*M->m22;

	M->m11=a.m11, M->m12=a.m12;
	M->m21=a.m21, M->m22=a.m22;

}

//---------------------------------------------------------------------------
bool CColorSpace::makeMatrix(MRX *a, MRX *b, double Cbm, double Crm, double Cgm)
{

	double Cbx= 0.5000, Cby= 0.0816;
	double Crx=-0.1687, Cry=-0.5000;
	double Cgx= 0.3312, Cgy=-0.4183;
	double d;

	MRX M,N;

	double Csin,Ccos,Clen;

	// ϊ
	Clen=sqrt(Cbx*Cbx + Cby*Cby);
	if (Clen==0) goto diverr;
	Csin=Cby/Clen;
	Ccos=Cbx/Clen;

	M.m11=(Cbm-1.0)*Ccos*Ccos+1,	M.m12=(1.0-Cbm)*Ccos*Csin;
	M.m21=(1.0-Cbm)*Ccos*Csin,		M.m22=(Cbm-1.0)*Csin*Csin+1;

	// ԕϊ
	Clen=sqrt(Crx*Crx + Cry*Cry);
	if (Clen==0) goto diverr;
	Csin=Cry/Clen;
	Ccos=Crx/Clen;

	N.m11=(Crm-1.0)*Ccos*Ccos+1,	N.m12=(1.0-Crm)*Ccos*Csin;
	N.m21=(1.0-Crm)*Ccos*Csin,		N.m22=(Crm-1.0)*Csin*Csin+1;

	makeMatrixsub(&M,&N);

	// Εϊ
	Clen=sqrt(Cgx*Cgx + Cgy*Cgy);
	if (Clen==0) goto diverr;
	Csin=Cgy/Clen;
	Ccos=Cgx/Clen;

	N.m11=(Cgm-1.0)*Ccos*Ccos+1,	N.m12=(1.0-Cgm)*Ccos*Csin;
	N.m21=(1.0-Cgm)*Ccos*Csin,		N.m22=(Cgm-1.0)*Csin*Csin+1;

	makeMatrixsub(&M,&N);

	a->m11=M.m11, a->m12=M.m12;
	a->m21=M.m21, a->m22=M.m22;

	d=M.m11*M.m22-M.m12*M.m21;
	if (d==0) goto diverr;

	b->m11= M.m22/d, b->m12=-M.m12/d;
	b->m21=-M.m21/d, b->m22= M.m11/d;

	return true;

diverr:
	a->m11=1.0, a->m12=0.0;
	a->m21=0.0, a->m22=1.0;

	b->m11=1.0, b->m12=0.0;
	b->m21=0.0, b->m22=1.0;

	return false;
}

//---------------------------------------------------------------------------
void CColorSpace::Create(int b, int r, int g, int p)
{

	int i;
	int fr=256,fg=256,fb=256;
	double n,m;

	switch (p) {
		case 0://web
			fr=fg=fb=6;
			break;
		case 1://333
			fr=fg=8, fb=4;
			break;
		case 2://333
			fr=fg=fb=8;
			break;
		case 3://444
			fr=fg=fb=16;
			break;
		case 4://555
			fr=fg=fb=32;
			break;
		case 5://655
			fr=fb=32; fg=64;
			break;
		case 6://666
			fr=fg=fb=64;
			break;
		case 7://777
			fr=fg=fb=128;
			break;
		case 8://888
			fr=fg=fb=256;
			break;
	}

	{
		maskcountr=fr;
		maskcountg=fg;
		maskcountb=fb;
		for (i=0;i<fr;i++) masktabler[i]=min((int)floor((double)i*256.0/(double)(fr-1)),255);
		for (i=0;i<fg;i++) masktableg[i]=min((int)floor((double)i*256.0/(double)(fg-1)),255);
		for (i=0;i<fb;i++) masktableb[i]=min((int)floor((double)i*256.0/(double)(fb-1)),255);
	}
/*
	for (i=0;i<256;i++) {
		gammatable[i]=pow((double)i / 255.0,GM);
	}
*/
	for (i=0;i<256;i++) {
		n=i/255.;

		if (n>=0.117647058823529411764705882352941)
			m=pow(n,3./2.2);
		else
			m=pow(n,1./2.2)*0.142913647595774056881018286010431;

		gtable[i]=m;

		if (n>=0.20198703620241161355887485889543)
			m=pow(n,3./2.2);
		else
			m=pow(n,2.2)*0.112905177848716256193056297677849/0.029628638340582134493141518902643;
		r2table[i]=m;

		if (n>=0.148670653233635731053932622069695)
			m=pow(n,3./2.2);
		else
			m=pow(n,2.2)*0.0743389203713377581101520770121405/0.0150971701329696556426866689396522;
		g2table[i]=m;

		if (n>=0.312422190652192596516505331287941)
			m=pow(n,3./2.2);
		else
			m=pow(n,2.2)*0.204649951175241102069736654437528/0.07734497816593886462882096069869;
		b2table[i]=m;

	}


	makeMatrix(&M1,&M2,(double)b/100.0,(double)r/100.0,(double)g/100.0);

}

//---------------------------------------------------------------------------
void CColorSpace::convRGBtoGCS(GCS *gcs, unsigned int rgb) const
{
	double r,g,b,n1,n2,n3,n22,n33;

	b=gtable[(rgb & 0xff)];
	g=gtable[(rgb & 0xff00)>>8];
	r=gtable[(rgb & 0xff0000)>>16];

	// ITU.BT-601 Y'CbCr 80%
	n1= (double)r*0.2989+(double)g*0.5866+(double)b*0.1145;//Y
	n2=-(double)r*0.1350-(double)g*0.2650+(double)b*0.4000;//Cb
	n3= (double)r*0.4000-(double)g*0.3346-(double)b*0.0653;//Cr

	n22=M1.m11*n2+M1.m12*n3;
	n33=M1.m21*n2+M1.m22*n3;

	gcs->Z=(int)floor(n1 *16384.0*255.0+.5);
	gcs->X=(int)floor(n22*16384.0*255.0+.5);
	gcs->Y=(int)floor(n33*16384.0*255.0+.5);

}

//---------------------------------------------------------------------------
int CColorSpace::convGCStoRGB(int X, int Y, int Z) const
{
	#define colortrim2(n) (max(0.0,min(1.0,n)))

	double R,G,B,x,y,z,rr,gg,bb,r3,g3,b3;
	int r,g,b;

	x=M2.m11*(double)X+M2.m12*(double)Y;
	y=M2.m21*(double)X+M2.m22*(double)Y;
	z=Z;
	// ITU.BT-601 Y'CbCr 80%
	R= z*0.9998247134019967+x*-0.000044452970991771824+y* 1.7528659800326482;
	G= z*1.0000893144198046+x*-0.4320813565838843+     y*-0.89314419804726;
	B= z*1.0000000115762946+x* 2.213731098385467+      y*-0.00011576294529099052;

	r3=colortrim2(R/255/16384);
	if (r3>=0.0540269630587776405948631399435028)
		rr=pow(r3,2.2/3.)*255;
	else
		rr=pow(r3/0.142913647595774056881018286010431,2.2)*255;

	g3=colortrim2(G/255/16384);
	if (g3>=0.0540269630587776405948631399435028)
		gg=pow(g3,2.2/3.)*255;
	else
		gg=pow(g3/0.142913647595774056881018286010431,2.2)*255;

	b3=colortrim2(B/255/16384);
	if (b3>=0.0540269630587776405948631399435028)
		bb=pow(b3,2.2/3.)*255;
	else
		bb=pow(b3/0.142913647595774056881018286010431,2.2)*255;

	r=(int)floor(rr+0.5);
	g=(int)floor(gg+0.5);
	b=(int)floor(bb+0.5);

	if (r<0) r=0; else if (r>255) r=255;
	if (g<0) g=0; else if (g>255) g=255;
	if (b<0) b=0; else if (b>255) b=255;

	return (b & 0xff) | ((g & 0xff)<<8) | ((r & 0xff) <<16);

}

//---------------------------------------------------------------------------
double CColorSpace::distanceGCS(GCS *g1, GCS *g2) const
{
	double x,y,z;

	z=(g1->Z - g2->Z);
	x=(g1->X - g2->X);
	y=(g1->Y - g2->Y);

	return (x*x)+(y*y)+(z*z);
}

//---------------------------------------------------------------------------
double CColorSpace::distanceGCSd(GCS *g1, int x2, int y2, int z2) const
{
	double x,y,z;

	z=(g1->Z - z2);
	x=(g1->X - x2);
	y=(g1->Y - y2);

	return (x*x)+(y*y)+(z*z);
}

//---------------------------------------------------------------------------
int CColorSpace::maskRGBsub(int m[], int mc, int in, int s)
{
	int r,i;
	if (s==0) {
    	r=0;
        for (i=0;i<mc;i++) if (r<m[i] && m[i]<=in) r=m[i];
    }
    else {
    	r=255;
        for (i=0;i<mc;i++) if (r>m[i] && m[i]>=in) r=m[i];
    }
    return r;
}

//---------------------------------------------------------------------------
int CColorSpace::maskRGB(int rgb)
{
	int r,g,b,vr,vg,vb,nrgb,rrgb=0,nr,ng,nb;
    GCS gcs1,gcs2;
	double nd,d;

    convRGBtoGCS(&gcs1,rgb);
    b=(rgb & 0xff);
    g=(rgb & 0xff00)>>8;
    r=(rgb & 0xff0000)>>16;

    d=DBL_MAX;
    for (vr=0;vr<2;vr++) for (vg=0;vg<2;vg++) for (vb=0;vb<2;vb++) {
    	nr=maskRGBsub(masktabler,maskcountr,r,vr);
    	ng=maskRGBsub(masktableg,maskcountg,g,vg);
    	nb=maskRGBsub(masktableb,maskcountb,b,vb);
        convRGBtoGCS(&gcs2,nrgb=((nb)|(ng<<8)|(nr<<16)));
        if (d>(nd=distanceGCS(&gcs1,&gcs2))) {
        	rrgb=nrgb;
            d=nd;
        }
    }
	return rrgb;
}
//---------------------------------------------------------------------------

