// DivideBox.cpp: CDivideBox NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "padie.h"
#include "DivideBox.h"

#include <math.h>
#include <float.h>
#include <limits.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
//////////////////////////////////////////////////////////////////////

static void  div_hsort(MED **ab, int n) {
	MED** a=ab-1;
	int i, j, k;
	MED* x;

	for (k = n / 2; k >= 1; k--) {
		i = k;  x = a[i];
		while ((j = 2 * i) <= n) {
			if (j < n && ((*(a+j))->flag < (*(a+j+1))->flag)) j++;
			if (x->flag >= (*(a+j))->flag) break;
			a[i] = a[j];  i = j;
		}
		a[i] = x;
	}
	while (n > 1) {
		x = a[n];  a[n] = a[1];  n--;
		i = 1;
		while ((j = 2 * i) <= n) {
			if (j < n && ((*(a+j))->flag < (*(a+j+1))->flag)) j++;
			if (x->flag >= (*(a+j))->flag) break;
			a[i] = a[j];  i = j;
		}
		a[i] = x;
	}

}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CDivideBox::CDivideBox()
{

}

CDivideBox::~CDivideBox()
{

}
#define dsqr(a) ((a)*(a))
//---------------------------------------------------------------------------
/*
static int qsortflag(const void *a,const void *b)
{

	double m=(( (*((MED **)a)) ->flag)-((*((MED **)b))->flag));
	if (m>0) return 1;
	if (m<0) return -1;
	return 0;

}
*/
//---------------------------------------------------------------------------
// return : ᏇubN̗vf
int CDivideBox::FindSquareDiv(MED **ix, int st, int n)
{
#define FSDtype 0
//////////////////////////////////////////////////
#if FSDtype==0
	struct GCSd {
		double X,Y,Z;
	};
	struct STC {
		GCSd total;
		double count;
		GCSd sqr;
	};

	MED **idx;
	STC L,R;
	int i,mk=0;
	double mn=DBL_MAX,m;
	GCSd a,b,d,e;
	double x,y,z,c;
	double xc,yc,zc;
	double mc;


	//f[^쐬------------------------------------------

	L.count=0;
	L.total.X=0, L.sqr.X=0;
	L.total.Y=0, L.sqr.Y=0;
	L.total.Z=0, L.sqr.Z=0;
	R.count=0;
	R.total.X=0, R.sqr.X=0;
	R.total.Y=0, R.sqr.Y=0;
	R.total.Z=0, R.sqr.Z=0;
	idx=ix+st;
	for (i=0;i<n;i++) {
		x=(**idx).gcs.X;
		y=(**idx).gcs.Y;
		z=(**idx).gcs.Z;
		c=(**idx).cnt;
		xc=x*c;
		yc=y*c;
		zc=z*c;

		R.count+=c;
		R.total.X+=xc;
		R.total.Y+=yc;
		R.total.Z+=zc;

		R.sqr.X+=xc*x;
		R.sqr.Y+=yc*y;
		R.sqr.Z+=zc*z;

		idx++;
	}
	a.X=R.total.X/R.count;
	a.Y=R.total.Y/R.count;
	a.Z=R.total.Z/R.count;

	R.sqr.X+=(double)a.X*a.X*R.count - 2.*a.X*R.total.X;
	R.sqr.Y+=(double)a.Y*a.Y*R.count - 2.*a.Y*R.total.Y;
	R.sqr.Z+=(double)a.Z*a.Z*R.count - 2.*a.Z*R.total.Z;

	//[v---------------------------------------------------
	idx=ix+st;
	for (i=1;i<n;i++) {
		x=(**idx).gcs.X;
		y=(**idx).gcs.Y;
		z=(**idx).gcs.Z;
		c=(**idx).cnt;
		xc=x*c;
		yc=y*c;
		zc=z*c;

		//Left side
		mc=max(L.count,1.);
		a.X=L.total.X/mc;
		a.Y=L.total.Y/mc;
		a.Z=L.total.Z/mc;
		mc=max(L.count+c,1.);
		d.X=(b.X=((e.X=(L.total.X+xc))/mc))-a.X;
		d.Y=(b.Y=((e.Y=(L.total.Y+yc))/mc))-a.Y;
		d.Z=(b.Z=((e.Z=(L.total.Z+zc))/mc))-a.Z;
		L.sqr.X+=d.X*d.X*L.count;
		L.sqr.Y+=d.Y*d.Y*L.count;
		L.sqr.Z+=d.Z*d.Z*L.count;
		L.total.X=e.X;
		L.total.Y=e.Y;
		L.total.Z=e.Z;
		L.count=mc;
		L.sqr.X+=dsqr(x-b.X)*c;
		L.sqr.Y+=dsqr(y-b.Y)*c;
		L.sqr.Z+=dsqr(z-b.Z)*c;

		//Right side
		mc=max(R.count,1.);
		a.X=R.total.X/mc;
		a.Y=R.total.Y/mc;
		a.Z=R.total.Z/mc;
		mc=max(R.count-c,1.);
		d.X=(b.X=((e.X=(R.total.X-x*c))/mc))-a.X;
		d.Y=(b.Y=((e.Y=(R.total.Y-y*c))/mc))-a.Y;
		d.Z=(b.Z=((e.Z=(R.total.Z-z*c))/mc))-a.Z;
		R.sqr.X+=d.X*d.X*R.count;
		R.sqr.Y+=d.Y*d.Y*R.count;
		R.sqr.Z+=d.Z*d.Z*R.count;
		R.total.X=e.X;
		R.total.Y=e.Y;
		R.total.Z=e.Z;
		R.count=mc;
		R.sqr.X-=dsqr(x-b.X)*c;
		R.sqr.Y-=dsqr(y-b.Y)*c;
		R.sqr.Z-=dsqr(z-b.Z)*c;

//		m=dsqr(L.sqr.X+L.sqr.Y+L.sqr.Z)+dsqr(R.sqr.X+R.sqr.Y+R.sqr.Z);
		m=(L.sqr.X+L.sqr.Y+L.sqr.Z)+(R.sqr.X+R.sqr.Y+R.sqr.Z);
		if (mn>m) {
			mn=m,	mk=i;
		}
		idx++;

	}

	return mk;
#endif
#if FSDtype==1
//////////////////////////////////////////////////
	struct GCSd {
		double F;//X,Y,Z;
	};
	struct STC {
		GCSd total;
		double count;
		GCSd sqr;
	};

	MED *idx;
	STC L,R;
	int i,mk=0;
	double mn=DBL_MAX,m;
	GCSd a,b,d,e;
	double f,c;
	double fc;
	double mc;


	//f[^쐬------------------------------------------

	L.count=0;
	L.total.F=0, L.sqr.F=0;
	R.count=0;
	R.total.F=0, R.sqr.F=0;
	idx=ix+st;
	for (i=0;i<n;i++) {
		f=(*idx).flag;
		c=(*idx).cnt;
		fc=f*c;

		R.count+=c;
		R.total.F+=fc;

		R.sqr.F+=fc*f;

		idx++;
	}
	a.F=R.total.F/R.count;

	R.sqr.F+=(double)a.F*a.F*R.count - 2.*a.F*R.total.F;

	//[v---------------------------------------------------
	idx=ix+st;
	for (i=1;i<n;i++) {
		f=(*idx).flag;
		c=(*idx).cnt;
		fc=f*c;

		//Left side
		mc=max(L.count,1.);
		a.F=L.total.F/mc;
		mc=max(L.count+c,1.);
		d.F=(b.F=((e.F=(L.total.F+fc))/mc))-a.F;
		L.sqr.F+=d.F*d.F*L.count;
		L.total.F=e.F;
		L.count=mc;
		L.sqr.F+=dsqr(f-b.F)*c;

		//Right side
		mc=max(R.count,1.);
		a.F=R.total.F/mc;
		mc=max(R.count-c,1.);
		d.F=(b.F=((e.F=(R.total.F-f*c))/mc))-a.F;
		R.sqr.F+=d.F*d.F*R.count;
		R.total.F=e.F;
		R.count=mc;
		R.sqr.F-=dsqr(f-b.F)*c;

//		m=dsqr(L.sqr.X+L.sqr.Y+L.sqr.Z)+dsqr(R.sqr.X+R.sqr.Y+R.sqr.Z);
		m=(L.sqr.F)+(R.sqr.F);
		if (mn>m) {
			mn=m,	mk=i;
		}
		idx++;

	}

	return mk;
#endif
}

void CDivideBox::jacobi(int n, double a[][3], double u[][3], double eps)
{
	bool finish;
	int m,i,j,k;
	double p,q,t,s2,c2,c,s,r;

	finish=false;

	for (m=0;m<10 && finish==false;m++) {
		finish = true;

		for (i=0;i<n-1;i++) {
			for (j=i+1;j<n;j++) {
				if (fabs(a[i][j])<eps) continue;
				finish=false;

				p = (a[i][i] - a[j][j]) / 2;
				q = a[i][j];
				t = p / q;
				s2 = 1 / sqrt(1 + t * t);
				if (q < 0) s2 = -s2;
				c2 = t * s2;
				if (c2 > 0) {
					c = sqrt((1 + c2) / 2);
					s = s2 / c / 2;
				}
				else {
					s = sqrt((1 - c2) / 2);
					c = s2 / s / 2;
				}
				r = a[i][i] + a[j][j];
				a[i][i] = r / 2 + p * c2 + q * s2;
				a[j][j] = r - a[i][i];
				a[i][j] = a[j][i] = 0;

				for (k = 0; k < n; k++) {
					if ((k != i) && (k != j)) {
						p = a[k][i];
						q = a[k][j];
						a[k][i] = a[i][k] =  p * c + q * s;
						a[k][j] = a[j][k] = -p * s + q * c;
					}
				}
				for (k = 0; k < n; k++){
					p = u[k][i];
					q = u[k][j];
					u[k][i] =  p * c + q * s;
					u[k][j] = -p * s + q * c;
				}
			}
		}
	}
//	if (finish==false)
//		MessageBox(Application->Handle,"#","Cube ave",MB_ICONINFORMATION);


}

double CDivideBox::setrma(MED **medbuf, int bs, int bn, RMA *prin, RMA *std, RMA *avg)
{
	double c;
	double d;
	double cnt=0;
	int i,j;

	avg->x=0;
	avg->y=0;
	avg->z=0;
	avg->c=0;
	if (bn<=0) return 0;

	for (i=0;i<bn;i++)
	{
		cnt+=c=(*medbuf[bs+i]).cnt;
		avg->x+=(double)(*medbuf[bs+i]).gcs.X * c;
		avg->y+=(double)(*medbuf[bs+i]).gcs.Y * c;
		avg->z+=(double)(*medbuf[bs+i]).gcs.Z * c;
	}
	avg->x/=cnt;
	avg->y/=cnt;
	avg->z/=cnt;
	avg->c=std->c=prin->c=cnt;
	//Us쐬
	{
		double d[3];
		int dx,dy;
		for (i=0;i<bn;i++) {
			c=(*medbuf[bs+i]).cnt;
			d[0]=(*medbuf[bs+i]).gcs.X - avg->x;
			d[1]=(*medbuf[bs+i]).gcs.Y - avg->y;
			d[2]=(*medbuf[bs+i]).gcs.Z - avg->z;

			for (dx=0;dx<3;dx++)
				for (dy=0;dy<3;dy++) {
					jca[dx][dy]+=d[dx]*d[dy]*c;
				};
		}
		for (dx=0;dx<3;dx++)
			for (dy=0;dy<3;dy++)
				jca[dx][dy]/=avg->c;

		for (dx=0;dx<3;dx++) {
			for (dy=0;dy<3;dy++) jcw[dx][dy]=0;
			jcw[dx][dx]=1;
		}
	}

	std->x=sqrt(jca[0][0]);
	std->y=sqrt(jca[1][1]);
	std->z=sqrt(jca[2][2]);

	jacobi(3, jca, jcw, pow(10,-16));
//	jacobi(3, jca, jcw, pow(10,-8));

	j=2; d=jca[j][j];
	for (i=0;i<3;i++) {
		if (d<jca[i][i]) {
			j=i;
			d=jca[i][i];
		}
	}

	prin->x=jcw[0][j];
	prin->y=jcw[1][j];
	prin->z=jcw[2][j];

	return d;
}

void CDivideBox::makeMEDbox(MEDBOX *medbox, MED **medbuf, int ad, int bs, int bn,CColorSpace *cs)
{
	int i;
	int mx,my,mz;
	double st;
	RMA prin,std,avg;
//	double dmn,dmx,dmw
//	double m;

	medbox[ad].bufstart=bs;
	medbox[ad].bufnum=bn;

	medbox[ad].firstd=setrma(medbuf,bs,bn,&prin,&std,&avg);
	memcpy(&medbox[ad].prin,&prin,sizeof(RMA));
	memcpy(&medbox[ad].std,&std,sizeof(RMA));
	memcpy(&medbox[ad].avg,&avg,sizeof(RMA));

	mx=(int)floor(avg.x+0.5);
	my=(int)floor(avg.y+0.5);
	mz=(int)floor(avg.z+0.5);

	medbox[ad].rgb=cs->maskRGB(cs->convGCStoRGB(mx,my,mz));

	medbox[ad].mid.X=mx;
	medbox[ad].mid.Y=my;
	medbox[ad].mid.Z=mz;


	// c
	st=0;
	for (i=bs;i<bs+bn;i++)
		st+=(cs->distanceGCSd(&((*medbuf[i]).gcs),mx,my,mz))*(double)(*medbuf[i]).cnt;
//		st+=sqrtz(distanceGCSd(&(medbuf[i].gcs),mx,my,mz))*medbuf[i].cnt;
	medbox[ad].strain=st;

}

bool CDivideBox::divideBox(MEDBOX *medbox, MED **medbuf, int mxa, int oi,CColorSpace *cs)
{

	int bs,bn,j;
//	double m;
	RMA prin,std,avg;


	bs=medbox[mxa].bufstart;
	bn=medbox[mxa].bufnum;
	if (bn==1) goto oneerr;

	// 听o
//	get_rma(bs,bn,&prin,&avg);
	memcpy(&prin,&medbox[mxa].prin,sizeof(RMA));
	memcpy(&std,&medbox[mxa].std,sizeof(RMA));
	memcpy(&avg,&medbox[mxa].avg,sizeof(RMA));

	#define nBOXDEV 1
	// {bNX}[N
//-------------------------------
#if nBOXDEV==0
	{
		double m=avg.x*prin.x + avg.y*prin.y + avg.z*prin.z;
		int mm=bs+bn;
		for (j=bs;j<mm;j++)
			(*medbuf[j]).flag=	(*medbuf[j]).gcs.X*prin.x+
								(*medbuf[j]).gcs.Y*prin.y+
								(*medbuf[j]).gcs.Z*prin.z;
		qsort(&medbuf[bs],bn,sizeof(MED*),qsortflag);

		j=bs,mm=bs+bn;  while (j<mm && (*medbuf[j]).flag<m) j++;
		j-=bs;

	}
#endif
//-------------------------------
#if nBOXDEV==1
	{
		int mm=bs+bn;
		for (j=bs;j<mm;j++)
			(*medbuf[j]).flag=	(*medbuf[j]).gcs.X*prin.x+
								(*medbuf[j]).gcs.Y*prin.y+
								(*medbuf[j]).gcs.Z*prin.z;
//		qsort(&medbuf[bs],bn,sizeof(MED*),qsortflag);
		div_hsort(&medbuf[bs],bn);
		j=FindSquareDiv(medbuf,bs,bn);

	//	MessageBox(Application->Handle,
	//		(AnsiString(j)+"/"+AnsiString(bn)).c_str(),
	//		"Total Box",MB_ICONINFORMATION);


	}
#endif
//-------------------------------
		if (j<1 || bn-j<1) {
			if (bn==2) j=1;
			else goto oneerr;
		}



	makeMEDbox(medbox,medbuf,mxa,bs,j,cs);
	makeMEDbox(medbox,medbuf,oi,bs+j,bn-j,cs);
	return true;
oneerr:
	makeMEDbox(medbox,medbuf,mxa,bs,bn,cs);
	medbox[mxa].strain=0;
	return false;
}
