// GraphArray.cpp: CGraphArray NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Padie.h"
#include "GraphArray.h"

#include <afxadv.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CGraphArray::CGraphArray()
{
	m_array=NULL;
	Width=0;
	Height=0;
	m_hDestinationDib=NULL;
	m_hSourceDib=NULL;

	for (int i=0;i<256;i++) m_palette[i]=i*256;

}

CGraphArray::~CGraphArray()
{
	if (m_array) free(m_array);
		//::GlobalFree((HGLOBAL) m_array);
	if (m_hDestinationDib) ::GlobalFree((HGLOBAL) m_hDestinationDib);
}

/////////////////////////////////////////////////////////////////////////////
// BITMAP\Lz֕ϊ
BOOL CGraphArray::MakeArray()
{
	LPBITMAPINFOHEADER lpBI;   // DIB \̂ւ̃|C^
	BOOL result_array=false;
	int bpp,cmp;
//	int *ma;

	if (m_hSourceDib == NULL)
		return result_array;

	/*
	 * DIB ւ̃|C^擾܂AԍŏɊ܂ł̂
	 * BITMAPINFO \̂łB
	 */
	lpBI = (LPBITMAPINFOHEADER) ::GlobalLock((HGLOBAL) m_hSourceDib);
	if (lpBI == NULL)
		return result_array;

	if (!IS_WIN30_DIB(lpBI))
	{
		::GlobalUnlock((HGLOBAL) m_hSourceDib);
		return result_array;       // ̃X^C DIB (ۑ̓T|[gĂ܂B)
	}

	//-----------------------------------------------------------------
	Width =lpBI->biWidth;
	Height=lpBI->biHeight;
	BitPerPixel=24;
	PaletteVolume=0;

	m_array=(int*)malloc(Width * Height * sizeof(int));
		//::GlobalAlloc(GMEM_FIXED | GMEM_ZEROINIT, Width * Height * sizeof(int));
		//if (m_array==NULL) goto errh0;

	bpp=lpBI->biBitCount;
	cmp=lpBI->biCompression;

	if (cmp==0 && (bpp!=16 && bpp!=32)) {
		unsigned char *tmp;
		int *pal;
		int rx,x,y;
		long ado;

		int usrc=lpBI->biClrUsed;
		if (usrc==0) usrc=1<<bpp;

		if (bpp<=8)	tmp=(unsigned char *)lpBI + lpBI->biSize + usrc * sizeof(RGBQUAD);
		else		tmp=(unsigned char *)lpBI + lpBI->biSize ;
		pal=(int *)((unsigned char *)lpBI + lpBI->biSize);


        switch (bpp) {
        	case 24:
            	{
					rx=(Width*3+3)&(~(3));
					for (y=0;y<Height;y++) {
		        		for (x=0;x<Width;x++) {
		            	    ado=((Height-y-1)*rx+x*3);
		            	    m_array[x+y*Width]=(tmp[ado+2]<<16)|(tmp[ado+1]<<8)|(tmp[ado]);
		            	}
                    }
		        }
                break;
            case 8:
            	{
					rx=(Width+3)&(~(3));
            		//for (i=0;i<usrc;i++) pal[i]=Read4rgb(mn);
					for (y=0;y<Height;y++) {
		        		for (x=0;x<Width;x++) {
		            	    ado=((Height-y-1)*rx+x);
		            	    m_array[x+y*Width]=pal[tmp[ado]];
		            	}
                    }
                }
                break;
            case 4:
            	{
					rx=(((Width+1)>>1)+3)&(~(3));
            		//for (i=0;i<usrc;i++) pal[i]=Read4rgb(mn);
					for (y=0;y<Height;y++) {
		        		for (x=0;x<Width;x++) {
		            	    ado=((Height-y-1)*rx+x/2);
                            if ((x & 1)==0)
		            	    	m_array[x+y*Width]=pal[tmp[ado]>>4];
                            else
		            	    	m_array[x+y*Width]=pal[tmp[ado] & 0xf];
		            	}
                    }
                }
                break;
            case 1:
				{
					rx=(((Width+7)>>3)+3)&(~(3));
            		//for (i=0;i<usrc;i++) pal[i]=Read4rgb(mn);
					for (y=0;y<Height;y++) {
		        		for (x=0;x<Width;x++) {
		            	    ado=((Height-y-1)*rx+x/8);
                            if (tmp[ado] & (1<<(7-(x & 7))))
		            	    	m_array[x+y*Width]=pal[1];
                            else
		            	    	m_array[x+y*Width]=pal[0];
		            	}
					}
				}
				break;
		}

	}

	result_array=TRUE;

	m_CRCnum=0;

	return result_array;
}

/////////////////////////////////////////////////////////////////////////////
// z񂩂BITMAP\L֕ϊ

int write24(unsigned char *mn, int c, int &, int &)
{
	unsigned char bf[4];//,n;

	if (c<0) return 0;
    *(int *)bf=c;
//unsigned char n=bf[0]; bf[0]=bf[2]; bf[2]=n;
	memcpy(mn,bf,3);
	return 3;	
}

int write8(unsigned char *mn, int c, int &, int &)
{
	unsigned char bf[1];

	if (c<0) return 0;
    bf[0]=(unsigned char)c;
	*mn=bf[0];
	return 1;
}

int write4(unsigned char *mn, int c, int &s, int &b)
{
//	unsigned char bf[1];

	if (c<0) {
		if (s!=0) {
			*mn=(unsigned char)b;
			return 1;
		}
        s=0;
    	return 0;
    }
    if (s==0) {
    	b=(unsigned char)(c<<4);
        s=1;
        return 0;
    }
    b|=(unsigned char)c;
	*(unsigned char *)mn=(unsigned char)b;
	s=0;
	return 1;
}

int write1(unsigned char *mn, int c, int &s, int &b)
{

	if (c<0) {
		if (s!=0) {
			*mn=(unsigned char)b;
			s=0,b=0;
			return 1;
		}
        s=0;
        b=0;
    	return 0;
    }

	b|=(unsigned char)(((unsigned char)c)<<(7-s));
    s++;
    if (s>=8) {
		*mn=(unsigned char)b;
    	s=0;
        b=0;
		return 1;
    }
	return 0;
}

BOOL CGraphArray::ReverseArray()
{
	//J
	if (m_hDestinationDib) ::GlobalFree((HGLOBAL) m_hDestinationDib);

    int indexvalue,picx,picy;
    unsigned char head[]={ //-14
		0x28,0x00,0x00,0x00,	//stracture size    -18         0
		0,0,0,0,	//width*****                                4
		0,0,0,0,	//height*****       -26                     8
		0x01,0x00,	//plane             -28                     12
		0x00,0x00,	//bpp                                       14
		0,0,0,0,	//comress                                   16
		0,0,0,0,	//imagesize*****                            20
		0,0,		// 000...                                   24
		0,0,        //                                          26
		0,0,0,0,    //                                          28
		0,0,0,0,    //  UsrClr                                  32
		0,0,0,0		//end                                       36
	};


	int i,j,wb,wd,pc;
	short int bpp;
	unsigned char pbf[4];
	long x,y;
//	int *madepalette;
//	unsigned char *palbuf;

//	int *ma;
	int (__cdecl *callwrite)(unsigned char *,int,int&,int&);
	int calls=0,callb=0;

	unsigned char *mn;

//	mn.SetLength(0);
	indexvalue=PaletteVolume;
	picx=Width;
	picy=Height;
//	madepalette=(int *)pd->Palette->Memory;
//	palbuf=(unsigned char *)pd->Picture->Memory;

	if (indexvalue==0) {
		bpp=24;
		callwrite=write24;
		wb=(picx*3+3) & ~3;
		wd=1;
		pc=0;
	}
	else if (indexvalue<=2) {
		bpp=1;
		callwrite=write1;
		wb=(((picx+7)/8+3) & ~3);
		wd=8;
		pc=indexvalue;//2;
	}
	else if (indexvalue<=16) {
		bpp=4;
		callwrite=write4;
		wb=(((picx+1)/2+3) & ~3);
		wd=2;
		pc=indexvalue;//16;
	}
	else {
		bpp=8;
		callwrite=write8;
		wb=(picx+3) & ~3;
		wd=1;
		pc=indexvalue;//256;
	}

	//---------------------------------̈m
	long szDib=sizeof(head) + pc*sizeof(RGBQUAD) + wb*picy;
//	ma=(int*) (::GlobalLock(m_array));
//	if (ma ==NULL) goto errh0;
	if ((m_hDestinationDib=((HDIB) ::GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT,szDib)))==NULL) goto errh0;
	mn=(unsigned char *) (::GlobalLock(m_hDestinationDib));
	if (mn ==NULL) goto errh1;
	

//	i=0x36+pc*sizeof(RGBQUAD);
//	*(int *)(head+0x0a-14)=i;

	i=wb *picy;
	*(int *)(head+0x22-14)=i;

//	i+=sizeof(head)+pc*sizeof(RGBQUAD);
//	*(int *)(head+0x02-14)=i;

	*(int *)(head+32+14-14)=pc;

	*(int *)(head+0x12-14)=picx;
	*(int *)(head+0x16-14)=picy;
	*(short int *)(head+0x1c-14)=bpp;

//	mn.Write(head,sizeof(head));
	memcpy(mn,head,sizeof(head)),mn+=sizeof(head);
	pbf[3]=0;
	for (i=0;i<indexvalue;i++) {
		j=m_palette[i];
		pbf[2]=(unsigned char)((j & 0x00ff0000)>>16);
		pbf[1]=(unsigned char)((j & 0x0000ff00)>>8);
		pbf[0]=(unsigned char)((j & 0x000000ff));
//		mn.Write(pbf,sizeof(pbf));
		memcpy(mn,pbf,sizeof(pbf)),mn+=sizeof(pbf);

	}
	pbf[0]=	pbf[1]=	pbf[2]=	pbf[3]=0;
	for (i=indexvalue;i<pc;i++) {
//		mn.Write(pbf,sizeof(pbf));
		memcpy(mn,pbf,sizeof(pbf)),mn+=sizeof(pbf);
	}


	for (y=picy-1;y>=0;y--) {
		int w=0;
		for (x=0;x<picx;x++) {
			if (indexvalue) {
			    mn+=callwrite(mn ,m_array[x+y*picx],calls,callb);
			    w++;
			}
			else {
			    mn+=callwrite(mn,m_array[x+y*picx],calls,callb);
			    w+=3;
			}
		}
		mn+=callwrite(mn,-1,calls,callb);
		w=((w+wd-1)/wd);
		for (x=w;x<((w+3) & ~3);x++) {
//			char bf[]={ 0 };
//			mn.Write(bf,1);
			*mn=0,mn++;
		}
	}

	::GlobalUnlock((HGLOBAL) m_hDestinationDib);
//	::GlobalUnlock((HGLOBAL) m_array);
	return TRUE;
errh1:
	::GlobalFree((HGLOBAL) m_hDestinationDib);
errh0:
//	::GlobalUnlock((HGLOBAL) m_array);
	return FALSE;
}

void CGraphArray::SetSourceDib(HDIB hDib)
{
	m_hSourceDib=hDib;
}

HDIB CGraphArray::GetDestinationDib()
{
	return m_hDestinationDib;
}

HDIB CGraphArray::DetachDestinationDib()
{
	HDIB a=m_hDestinationDib;
	m_hDestinationDib=NULL;
	return a;
}


void CGraphArray::ClearArray()
{
	if (m_array) free(m_array);
	m_array=NULL;
}
