// OpenFileDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "padie.h"
#include "OpenFileDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenFileDialog

COpenFileDialog::COpenFileDialog(HWND hd)
{
	h=hd;
	DefaultExt="";
	FileName="";
    Files=new CStringList;
	Files->RemoveAll();
	Filter="ׂẴt@C(*.*)|*.*";
	FilterIndex=1;
	InitialDir="";
	Title="";
	Flags=OFN_FILEMUSTEXIST | OFN_HIDEREADONLY |OFN_ALLOWMULTISELECT |OFN_EXPLORER;
}

COpenFileDialog::~COpenFileDialog()
{
	delete Files;
}

/////////////////////////////////////////////////////////////////////////////
// COpenFileDialog bZ[W nh
//---------------------------------------------------------------------------
static const char* AnsiLastChar(const char *p)
{
	const unsigned char *pt=(unsigned char*)p;
	size_t sz=_mbslen(pt);
	if (sz) pt=_mbsninc(pt,sz-1);
	return (char*) pt;
}
//---------------------------------------------------------------------------
void ExtractFileDir(CString &s)
{
	/// pXo
	char path_buffer[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];

	_splitpath( s , drive, dir, fname, ext );
	_makepath( path_buffer, drive, dir, NULL, NULL );
	s=path_buffer;

}
void GetAppPathName(CString &s)
{
	char path_buffer[_MAX_PATH];

	GetModuleFileName( NULL, path_buffer, _MAX_PATH );
	s=path_buffer;
}
void FileAddYen(CString &s)
{
	if (*(AnsiLastChar((LPCTSTR) s))!='\\') s+="\\";
}


//---------------------------------------------------------------------------
static void tokcnv(char *pt,int l)
{
	for (int i=0;i<l;i++) {
		if (*pt=='|') *pt='\0';
		pt++;
	}
}
//---------------------------------------------------------------------------

BOOL COpenFileDialog::Execute()
{

	OPENFILENAME ofn;
	BOOL i;
	int m;
	char* szBuffer = new char[m=Filter.GetLength()+2];
	char *szFn=new char [16000];
	char *pt;

	memset(szFn,0,16000);
	strcpy(szBuffer, Filter+"|");
	tokcnv(szBuffer,m);

	*szFn=0;
	ZeroMemory(&ofn, sizeof(OPENFILENAME));

	lstrcpy(szFn,FileName);
	
	ofn.lStructSize=sizeof(OPENFILENAME);
	ofn.hwndOwner=h;//GetOwner()->m_hWnd;
	ofn.lpstrFilter= szBuffer;
	ofn.lpstrCustomFilter=NULL;
	ofn.nMaxCustFilter=0;
	ofn.nFilterIndex=FilterIndex;
	ofn.lpstrFile=szFn;
	ofn.nMaxFile=15997;
	ofn.lpstrFileTitle=NULL;
	ofn.nMaxFileTitle=0;
	ofn.lpstrInitialDir=InitialDir;
	ofn.lpstrTitle=Title;
	ofn.Flags=Flags;
	ofn.nFileOffset=0;
	ofn.nFileExtension=0;
	ofn.lpstrDefExt=DefaultExt;
	ofn.lCustData=0;
	ofn.lpfnHook=NULL;
	ofn.lpTemplateName=NULL;

	i=GetOpenFileName(&ofn);

	delete [] szBuffer;

	if (!i) {
		delete [] szFn;
		return FALSE;

	}

	FilterIndex=ofn.nFilterIndex;

	pt=szFn;
	FileName=CString(szFn);
	Files->RemoveAll();
	while (*pt++);
	if (*pt) {
		//multi
		if (*(AnsiLastChar((LPCTSTR) FileName))!='\\') FileName+="\\";
		while (1) {
			Files->AddTail(FileName+pt);
			while (*pt++);
			if (!*pt) break;
		}
		FileName=Files->GetAt(Files->GetHeadPosition());
	}
	else {
		Files->AddTail(FileName);
	}


	InitialDir=FileName;
	ExtractFileDir(InitialDir);

	delete [] szFn;
	return TRUE;

}


/////////////////////////////////////////////////////////////////////////////
// CSaveFileDialog

CSaveFileDialog::CSaveFileDialog(HWND hd)
{
	h=hd;
	DefaultExt="";
	FileName="";
//    Files=new CStringList;
//	Files->RemoveAll();
	Filter="ׂẴt@C(*.*)|*.*";
	FilterIndex=1;
	InitialDir="";
	Title="";
	Flags=	OFN_HIDEREADONLY |OFN_EXPLORER |OFN_OVERWRITEPROMPT;
}

CSaveFileDialog::~CSaveFileDialog()
{
//	delete Files;
}


BOOL CSaveFileDialog::Execute()
{

	OPENFILENAME ofn;
	BOOL i;
	int m;
	char* szBuffer = new char[m=Filter.GetLength()+2];
	char *szFn=new char [512];

	strcpy(szBuffer,Filter+"|");
	tokcnv(szBuffer,m);

	*szFn=0;
	ZeroMemory(&ofn, sizeof(OPENFILENAME));

	lstrcpy(szFn,FileName);

	ofn.lStructSize=sizeof(OPENFILENAME);
	ofn.hwndOwner=h;
	ofn.lpstrFilter= szBuffer;
	ofn.lpstrCustomFilter=NULL;
	ofn.nMaxCustFilter=0;
	ofn.nFilterIndex=FilterIndex;
	ofn.lpstrFile=szFn;
	ofn.nMaxFile=512;
	ofn.lpstrFileTitle=NULL;
	ofn.nMaxFileTitle=0;
	ofn.lpstrInitialDir=InitialDir;
	ofn.lpstrTitle=Title;
	ofn.Flags=Flags;
	ofn.nFileOffset=0;
	ofn.nFileExtension=0;
	ofn.lpstrDefExt=DefaultExt;
	ofn.lCustData=0;
	ofn.lpfnHook=NULL;
	ofn.lpTemplateName=NULL;

	i=GetSaveFileName(&ofn);

	delete [] szBuffer;

	if (!i) {
		delete [] szFn;
		return false;

	}

	FilterIndex=ofn.nFilterIndex;

	FileName=szFn;

	InitialDir=FileName;
	ExtractFileDir(InitialDir);

	delete [] szFn;
	return true;
}
