// PadieDoc.cpp : CPadieDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "Padie.h"
#include "MainFrm.h"
#include "GraphArray.h"
#include <iostream.h>

#include "PadieDoc.h"
#include "Quant.h"
#include "PadieView.h"
#include "CControllPanel.h"
#include "QuantSign.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPadieDoc

IMPLEMENT_DYNCREATE(CPadieDoc, CDocument)

BEGIN_MESSAGE_MAP(CPadieDoc, CDocument)
	//{{AFX_MSG_MAP(CPadieDoc)
	ON_COMMAND(ID_EDIT_PROPERTY, OnEditProperty)
	ON_COMMAND(ID_DO_QUANT, OnDoQuant)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_UPDATE_COMMAND_UI(ID_DO_QUANT, OnUpdateDoQuant)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPadieDoc NX̍\z/

CPadieDoc::CPadieDoc()
{
	m_hDIB = NULL;
	m_palDIB = NULL;
	m_sizeDoc = CSize(100,100);     // CScrollView ܂쐬邽߂̃_~[l
	m_nView=1;
	m_Lock=FALSE;
	m_CanQuant=TRUE;

}

CPadieDoc::~CPadieDoc()
{
	if (m_hDIB != NULL)
	{
		::GlobalFree((HGLOBAL) m_hDIB);
	}
	if (m_palDIB != NULL)
	{
		delete m_palDIB;
	}
}

BOOL CPadieDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	m_sizeDoc=((CPadieApp*)AfxGetApp())->m_stockSize;
	return true;
}



/////////////////////////////////////////////////////////////////////////////
// CPadieDoc VAC[[V

void CPadieDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB

	}
}

/////////////////////////////////////////////////////////////////////////////
// CPadieDoc NX̐ff

#ifdef _DEBUG
void CPadieDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CPadieDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPadieDoc R}h

void CPadieDoc::ReplaceHDIB(HDIB hDIB)
{
	if (m_hDIB != NULL)
	{
		::GlobalFree((HGLOBAL) m_hDIB);
	}
	m_hDIB = hDIB;
}

void CPadieDoc::InitDIBData()
{
	if (m_palDIB != NULL)
	{
		delete m_palDIB;
		m_palDIB = NULL;
	}
	if (m_hDIB == NULL)
	{
		return;
	}
	// hLg TCY̐ݒ
	LPSTR lpDIB = (LPSTR) ::GlobalLock((HGLOBAL) m_hDIB);
	if (::DIBWidth(lpDIB) > INT_MAX ||::DIBHeight(lpDIB) > INT_MAX)
	{
		::GlobalUnlock((HGLOBAL) m_hDIB);
		::GlobalFree((HGLOBAL) m_hDIB);
		m_hDIB = NULL;
		CString strMsg;
		strMsg.LoadString(IDS_DIB_TOO_BIG);
		MessageBox(NULL, strMsg, NULL, MB_ICONINFORMATION | MB_OK);
		return;
	}
	m_sizeDoc = CSize((int) ::DIBWidth(lpDIB), (int) ::DIBHeight(lpDIB));
	::GlobalUnlock((HGLOBAL) m_hDIB);
	// pbg̃Rs[쐬܂B
	m_palDIB = new CPalette;
	if (m_palDIB == NULL)
	{
		// ł͖{ɏłB
		::GlobalFree((HGLOBAL) m_hDIB);
		m_hDIB = NULL;
		return;
	}
	if (::CreateDIBPalette(m_hDIB, m_palDIB) == NULL)
	{
		// DIB ̓pbgĂȂ\܂B
		delete m_palDIB;
		m_palDIB = NULL;
		return;
	}
}

BOOL CPadieDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	CFile file;
	CFileException fe;

	if (!file.Open(lpszPathName, CFile::modeCreate |
	  CFile::modeReadWrite | CFile::shareExclusive, &fe))
	{
		ReportSaveLoadException(lpszPathName, &fe,
			TRUE, AFX_IDP_INVALID_FILENAME);
		return FALSE;
	}

	// VACYp̌Ăяo SaveDIB ֐ɒu܂B
	BOOL bSuccess = FALSE;
	TRY
	{
		BeginWaitCursor();
		bSuccess = ::SaveDIB(m_hDIB, file);
		file.Close();
	}
	CATCH (CException, eSave)
	{
		file.Abort(); // OX[܂B
		EndWaitCursor();
		ReportSaveLoadException(lpszPathName, eSave,
			TRUE, AFX_IDP_FAILED_TO_SAVE_DOC);
		return FALSE;
	}
	END_CATCH

	EndWaitCursor();
	SetModifiedFlag(FALSE);     // COɖ߂܂B

	if (!bSuccess)
	{
		// ̃X^C DIB ܂B([h̓T|[gĂ܂Aۑł܂)
		// ܂ SaveDIB ̖̑肩܂B
		CString strMsg;
		strMsg.LoadString(IDS_CANNOT_SAVE_DIB);
		MessageBox(NULL, strMsg, NULL, MB_ICONINFORMATION | MB_OK);
	}

	return bSuccess;
}

BOOL CPadieDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	CFile file;
	CFileException fe;
	if (!file.Open(lpszPathName, CFile::modeRead | CFile::shareDenyWrite, &fe))
	{
		ReportSaveLoadException(lpszPathName, &fe,
			FALSE, AFX_IDP_FAILED_TO_OPEN_DOC);
		return FALSE;
	}

	DeleteContents();
	BeginWaitCursor();

	// VACYp̌Ăяo ReadDIBFile ֐ɒu܂B
	TRY
	{
		m_hDIB = GetSusiePicture(lpszPathName);
		if (!m_hDIB) m_hDIB = ::ReadDIBFile(file);
	}
	CATCH (CFileException, eLoad)
	{
		file.Abort(); // OX[܂B
		EndWaitCursor();
		ReportSaveLoadException(lpszPathName, eLoad,
			FALSE, AFX_IDP_FAILED_TO_OPEN_DOC);
		m_hDIB = NULL;
		return FALSE;
	}
	END_CATCH

	InitDIBData();
	EndWaitCursor();

	if (m_hDIB == NULL)
	{
		// DIB tH[}bgł͂Ȃ\܂B
		CString strMsg;
		strMsg.LoadString(IDS_CANNOT_LOAD_DIB);
		MessageBox(AfxGetMainWnd()->m_hWnd, strMsg, NULL, MB_ICONINFORMATION | MB_OK | MB_SYSTEMMODAL);
		return FALSE;
	}
	SetPathName(lpszPathName);
	SetModifiedFlag(FALSE);     // C𖳌ɂĎn߂܂B
	return TRUE;
}

void CPadieDoc::OnEditProperty() 
{
	CGraphArray cg;
	unsigned char *fg;

	cg.SetSourceDib(m_hDIB);
	if (cg.MakeArray()==TRUE) {
		//
		unsigned char mk[]={ 1, 2, 4, 8, 16, 32, 64, 128 };
		int x,y,n,picx,picy,c=0;
		fg=(unsigned char *)malloc(256*256*256/8);
		memset(fg,0,256*256*256/8);

		picx=cg.Width;
		picy=cg.Height;

		for (y=0;y<picy;y++) for (x=0;x<picx;x++) {
			n=cg.m_array[x+y*picx];
			if ((fg[n>>3] & mk[n & 7])==0) {
				fg[n>>3]|=mk[n & 7];
				c++;
			}
		}
		free(fg);

		{
			//\
			CString strMsg,s;
			strMsg.LoadString(IDS_GRAPH_PROPERTY);
			s.Format(strMsg, cg.Width, cg.Height, c);
			AfxMessageBox(s,MB_ICONINFORMATION | MB_OK);
		}

	}
	return ;
}

void CPadieDoc::StuffDocument(HDIB hDib)
{
		{
			ReplaceHDIB(hDib); // Â DIB ܂B
			InitDIBData();    // VTCYуpbg̐ݒ
			SetModifiedFlag(FALSE);
		}
}

///////////////////////////////////////////////////////////////////////////
UINT QuantThread( LPVOID pvParam )
{
	int minpal=0;
	CQuant *q;
	q=new CQuant;
	q->pvParam=(CPadieDoc*)pvParam;
	CControllPanel* qp=&((CMainFrame*)((CMDIFrameWnd*)AfxGetApp()->m_pMainWnd))->m_cpl;
	
	switch (qp->m_InBit +5) {
		case 5:
			q->picturemask=7;
			break;
		case 6:
			q->picturemask=3;
			break;
		case 7:
			q->picturemask=1;
			break;
		default:
			q->picturemask=0;
			break;
	}

	switch (qp->m_BitSet) {
		case 0:
			q->indexvolume=256;
			break;
		case 1:
			q->indexvolume=16;
			break;
		case 2:
			q->indexvolume=2;
			break;
		default:
			q->indexvolume=qp->m_numBit;
			break;
	}

	q->paletteprecision=qp->m_OutBit;
	q->CbMag=qp->m_magYB*5+50-15;
	q->CrMag=qp->m_magCR*5+50+ 5;
	q->CgMag=qp->m_magGM*5+50+25;
	
	q->ditherlevel=qp->m_DitherLevel;
	q->add16palette=qp->m_Add16;
	q->transparencycolor=qp->m_TransMode ? qp->m_TransPosition :-1;
	q->dithermode=qp->m_DitherMode;

	if (q->add16palette) minpal+=16;
	if (q->transparencycolor>=0) minpal++;
	if (q->indexvolume<minpal) q->indexvolume=minpal;

	q->Execute();
	delete q;

	return 0;
}

void CALLBACK EXPORT ProgTimerProc(
   HWND /*hWnd*/,      // SetTimer Ăяo CWnd  nh
   UINT /*nMsg*/,      // WM_TIMER
   UINT /*nIDEvent*/,  // ^C} ʎq
   DWORD /*dwTime*/    // VXe 
)
{
	((CMainFrame*)((CMDIFrameWnd*)AfxGetApp()->m_pMainWnd))->
		SetPos(theQuantSign.m_ProgPosition);
}

void CPadieDoc::OnDoQuant() 
{
	CMainFrame *pFrame = 
				 (CMainFrame*)AfxGetApp()->m_pMainWnd;
	// ANeBu MDI qEBhE擾B 
	CMDIChildWnd *pChild = pFrame->MDIGetActive();
	// ANeBu MDI qEBhEɌѕtĂANeBuȃr[擾B
	CPadieDoc *pd = (CPadieDoc *) pChild->GetActiveView()->GetDocument();

	if (pFrame->m_cpl.DoModal() == IDOK)
	{	
		if (pd) {
			m_GraphArray.SetSourceDib(pd->m_hDIB);

			if (( theQuantSign.m_pThread = AfxBeginThread((AFX_THREADPROC)QuantThread, 
							(LPVOID)this,THREAD_PRIORITY_IDLE,0,CREATE_SUSPENDED,NULL) ) !=NULL) 	{
				// Xbh쐬
				theQuantSign.m_pThread->m_bAutoDelete = TRUE;
				theQuantSign.m_pThread->ResumeThread();                     // TXyhI
				theQuantSign.m_ThreadBeing=TRUE;
				theQuantSign.m_ProgTimer=pFrame->SetTimer(1,1000,ProgTimerProc);
				m_Lock=TRUE;
				pFrame->m_wndStatusBar.SendMessage(WM_SETTEXT,0,(LPARAM)"@");
			}
		}
	}
}

void CPadieDoc::QuantThreadDone()
{
	if (m_GraphArray.GetDestinationDib() != NULL)
	{
		LPSTR lpDIB = (LPSTR) ::GlobalLock((HGLOBAL) m_GraphArray.GetDestinationDib());
		((CPadieApp *)AfxGetApp())->m_stockSize = CSize((int) ::DIBWidth(lpDIB), (int) ::DIBHeight(lpDIB));
		::GlobalUnlock((HGLOBAL) m_GraphArray.GetDestinationDib());

		CPadieDoc *pd;
		pd=(CPadieDoc *)(theQuantSign.m_graphdoc->OpenDocumentFile(NULL));
		pd->SetPathName(GetPathName(),FALSE);
		#ifdef _DEBUG
		{
			CString s,t;
			int i;
			t=" ";
			for (i=0;i<m_GraphArray.m_CRCnum;i++) {
				s.Format(":%08lX",m_GraphArray.m_CRC[i]);
				t+=s;
			}
			pd->SetTitle(GetTitle()+t);
		}
		#else
		{
			CString s;
			s.Format("(%d)",m_GraphArray.PaletteVolume);
			pd->SetTitle(GetTitle()+s);
		}
		#endif

		pd->StuffDocument(m_GraphArray.DetachDestinationDib());
		pd->m_CanQuant=FALSE;
		MessageBeep(MB_ICONASTERISK);
	}
	else
	{
		MessageBeep(MB_ICONEXCLAMATION);
	}

	theQuantSign.m_pThread=NULL;

	CMainFrame* pMain=(CMainFrame*)(AfxGetApp()->m_pMainWnd);
	pMain->KillTimer(theQuantSign.m_ProgTimer);
	theQuantSign.m_ProgTimer=0;
	theQuantSign.m_ProgPosition=0;
	pMain->SetPos(0);

	m_Lock=FALSE;
	theQuantSign.m_ThreadBeing=FALSE;

}


void CPadieDoc::OnFileSaveAs() 
{
	CMainFrame *pMf=(CMainFrame*)AfxGetMainWnd();
	{
		/// pXo
		char path_buffer[_MAX_PATH];
		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		char fname[_MAX_FNAME];
		char ext[_MAX_EXT];

		_splitpath( GetPathName() , drive, dir, fname, ext );
		_makepath( path_buffer , NULL, NULL, fname, NULL);
		pMf->m_dSaveFile->FileName=path_buffer;
	}
	if (pMf->m_dSaveFile->Execute()) {
		OnSaveDocument(pMf->m_dSaveFile->FileName);
	}

}

void CPadieDoc::OnFileOpen() 
{
	CMainFrame *pMf=(CMainFrame*)AfxGetMainWnd();
	pMf->AsFileOpen();
}

void CPadieDoc::OnUpdateDoQuant(CCmdUI* pCmdUI) 
{
	BOOL a=FALSE;

	if (!theQuantSign.m_ThreadBeing && m_CanQuant) a=TRUE;
	pCmdUI->Enable(a);
}

BOOL CPadieDoc::CanCloseFrame(CFrameWnd* /*pFrame*/) 
{
	if (m_Lock) return FALSE;
	else return TRUE;
//	return CDocument::CanCloseFrame(pFrame);
}
