#ifndef __VER_RES_H__
#define __VER_RES_H__

#pragma comment(linker,"/DEFAULTLIB:version.lib")

#define		DefineStringResource(name)											\
CString		Get##name(void) const {												\
	CString		key;													\
	key.Format(_T("\\StringFileInfo\\%04X%04X\\")#name,*m_pLangID,*(m_pLangID+1));						\
	TCHAR		*p;													\
	UINT		tmp;													\
	if (::VerQueryValue(m_pBlock,(LPTSTR)(LPCTSTR)key,(void**)&p,&tmp)) {							\
		CString		rc(p,tmp);											\
		rc.ReleaseBuffer();												\
		return rc;													\
	}															\
	return _T("");														\
}

#define		DefineVersionResource(name)											\
CString		Get##name(void) const {												\
	CString		cs=_T("");												\
	if (m_pBlock) cs.Format(_T("%d.%d.%d build(%d)"),HIWORD(m_pFixedFileInfo->dw##name##MS),				\
		LOWORD(m_pFixedFileInfo->dw##name##MS),HIWORD(m_pFixedFileInfo->dw##name##LS),					\
		LOWORD(m_pFixedFileInfo->dw##name##LS));									\
	return cs;														\
}

#define		DefineVersionResourceShort(name)										\
CString		Get##name##Short(void) const {											\
	CString		cs=_T("");												\
	if (m_pBlock) cs.Format(_T("%d.%d"),HIWORD(m_pFixedFileInfo->dw##name##MS),LOWORD(m_pFixedFileInfo->dw##name##MS));	\
	return cs;														\
}


class CVerRes {
protected:
	void			*m_pBlock;
	VS_FIXEDFILEINFO	*m_pFixedFileInfo;
	WORD			*m_pLangID;
public:
			CVerRes(void) {
				TCHAR		lpszFileName[MAX_PATH];
				::GetModuleFileName(AfxGetApp()->m_hInstance,lpszFileName,sizeof(lpszFileName));
				DWORD		dwSize=::GetFileVersionInfoSize((LPTSTR)lpszFileName,0);
				m_pBlock=new char[dwSize];
				UINT		tmp,tmp2;
				if (!::GetFileVersionInfo((LPTSTR)lpszFileName,0,dwSize,m_pBlock)||
						!::VerQueryValue(m_pBlock,_T("\\"),(void**)&m_pFixedFileInfo,&tmp)||
						!::VerQueryValue(m_pBlock,_T("\\VarFileInfo\\Translation"),(void**)&m_pLangID,&tmp2)) {
					delete [] m_pBlock;
					m_pBlock=NULL;
				}
			}
	virtual		~CVerRes(void) { delete [] m_pBlock; }
	DefineVersionResource(FileVersion);
	DefineVersionResource(ProductVersion);
	DefineVersionResourceShort(FileVersion);
	DefineVersionResourceShort(ProductVersion);
	DefineStringResource(Comments);
	DefineStringResource(CompanyName);
	DefineStringResource(FileDescription);
	DefineStringResource(InternalName);
	DefineStringResource(LegalCopyright);
	DefineStringResource(LegalTrademarks);
	DefineStringResource(OriginalFilename);
	DefineStringResource(PrivateBuild);
	DefineStringResource(ProductName);
	DefineStringResource(SpecialBuild);
};

#endif
