//  dibapi.cpp
//
//  foCX CfByfg rbg}bv (DIB) API ̃\[Xt@CB
//  ȉ̊֐񋟂܂:
//
//  PaintDIB()          - DIB ̃yCg [`łB
//  CreateDIBPalette()  - DIB pbg쐬܂B
//  FindDIBBits()       - DIB rbgփ|C^Ԃ܂B
//  DIBWidth()          - DIB ̕擾܂B
//  DIBHeight()         - DIB ̍擾܂B
//  PaletteSize()       - DIB ̃pbg̕ۑɕKvȃTCY擾܂B
//  DIBNumColors()      - DIB ̃J[ e[u̐FvZ܂B
//                        
//  CopyHandle()        - w肳ꂽO[o  ubÑRs[쐬܂B
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// ̃\[X R[h Microsoft Foundation Class t@XсA
// ֘AIC hLg̕⑫݂̂ړIƂĂ܂B
// Microsoft Foundation Class iɊւڂ͂̃hLg
// QƂĂB
//

#include "stdafx.h"
#include "dibapi.h"
#include <io.h>
#include <errno.h>

/*************************************************************************
 *
 * PaintDIB()
 *
 * p[^:
 *
 * HDC hDC          - o͗p DC 
 *
 * LPRECT lpDCRect  - o͗p DC ̎lp`
 *
 * HDIB hDIB        - DIB rbgɏ] DIB XybN O[p
 *                    ւ̃nh
 *
 * LPRECT lpDIBRect - lpDCRect ֏o͂邽߂ DIB ̎lp`
 *
 * CPalette* pPal   - DIB ̃pbg܂ CPalette 
 *
 * ߂l:
 *
 * BOOL             - DIB `悳ꂽꍇ TRUEA ȊȌꍇ FALSE
 *
 * :
 *   DIB p̃yCg [`łB DIB yCg邽߂ StretchDIBits()
 *   ܂ SetDIBitsToDevice() ĂяoĂBDIB ͎w肳ꂽ DC 
 *   lpDCRect Ŏw肳ꂽR[fBlCgŏo͂܂B
 *   DIB ̏o̓GA lpDIBRect ɂė^܂B
 *   
 *
 ************************************************************************/

BOOL WINAPI PaintDIB(HDC     hDC,
					LPRECT  lpDCRect,
					HDIB    hDIB,
					LPRECT  lpDIBRect,
					CPalette* pPal)
{
	LPSTR    lpDIBHdr;            // BITMAPINFOHEADER ւ̃|C^
	LPSTR    lpDIBBits;           // DIB rbgւ̃|C^
	BOOL     bSuccess=FALSE;      // /s
	HPALETTE hPal=NULL;           // DIB ̃pbg
	HPALETTE hOldPal=NULL;        // Õpbg

	/* L DIB nhǂmF */
	if (hDIB == NULL)
		return FALSE;

	/* DIB bNărbg obt@̊Jn_ւ̃|C^擾
	 * ܂B
	 */
	lpDIBHdr  = (LPSTR) ::GlobalLock((HGLOBAL) hDIB);
	lpDIBBits = ::FindDIBBits(lpDIBHdr);

	// DIB ̃pbg擾āADC łI܂B
	if (pPal != NULL)
	{
		hPal = (HPALETTE) pPal->m_hObject;

		// OiɎĂ邽߁AKvȂΔwiƂ
		// IĂB
		hOldPal = ::SelectPalette(hDC, hPal, TRUE);
	}

	/* J[ sN`[ɍœKȂ悤ɃXgb` [hgpĂ邱ƂmFĂB */
	::SetStretchBltMode(hDC, COLORONCOLOR);

	/* StretchDIBits() ܂ SetDIBitsToDevice() ̂ǂĂяo肵܂B */
	if ((RECTWIDTH(lpDCRect)  == RECTWIDTH(lpDIBRect)) &&
	   (RECTHEIGHT(lpDCRect) == RECTHEIGHT(lpDIBRect)))
		bSuccess = ::SetDIBitsToDevice(hDC,                    // hDC
								   lpDCRect->left,             // DestX
								   lpDCRect->top,              // DestY
								   RECTWIDTH(lpDCRect),        // nDestWidth
								   RECTHEIGHT(lpDCRect),       // nDestHeight
								   lpDIBRect->left,            // SrcX
								   (int)DIBHeight(lpDIBHdr) -
									  lpDIBRect->top -
									  RECTHEIGHT(lpDIBRect),   // SrcY
								   0,                          // nStartScan
								   (WORD)DIBHeight(lpDIBHdr),  // nNumScans
								   lpDIBBits,                  // lpBits
								   (LPBITMAPINFO)lpDIBHdr,     // lpBitsInfo
								   DIB_RGB_COLORS);            // wUsage
   else
	  bSuccess = ::StretchDIBits(hDC,                          // hDC
							   lpDCRect->left,                 // DestX
							   lpDCRect->top,                  // DestY
							   RECTWIDTH(lpDCRect),            // nDestWidth
							   RECTHEIGHT(lpDCRect),           // nDestHeight
							   lpDIBRect->left,                // SrcX
								   (int)DIBHeight(lpDIBHdr) -
									  lpDIBRect->top -
									  RECTHEIGHT(lpDIBRect),   // SrcY
//							   lpDIBRect->top,                 // SrcY
							   RECTWIDTH(lpDIBRect),           // wSrcWidth
							   RECTHEIGHT(lpDIBRect),          // wSrcHeight
							   lpDIBBits,                      // lpBits
							   (LPBITMAPINFO)lpDIBHdr,         // lpBitsInfo
							   DIB_RGB_COLORS,                 // wUsage
							   SRCCOPY);                       // dwROP
/*
	  bSuccess = ::StretchDIBits(hDC,                          // hDC
							   lpDCRect->left,                 // DestX
							   lpDCRect->top,                  // DestY
							   RECTWIDTH(lpDCRect),            // nDestWidth
							   RECTHEIGHT(lpDCRect),           // nDestHeight
							   lpDIBRect->left,                // SrcX
							   lpDIBRect->top,                 // SrcY
							   RECTWIDTH(lpDIBRect),           // wSrcWidth
							   RECTHEIGHT(lpDIBRect),          // wSrcHeight
							   lpDIBBits,                      // lpBits
							   (LPBITMAPINFO)lpDIBHdr,         // lpBitsInfo
							   DIB_RGB_COLORS,                 // wUsage
							   SRCCOPY);                       // dwROP
*/
   ::GlobalUnlock((HGLOBAL) hDIB);

	/* ÂpbgđI */
	if (hOldPal != NULL)
	{
		::SelectPalette(hDC, hOldPal, TRUE);
	}

   return bSuccess;
}

/*************************************************************************
 *
 * CreateDIBPalette()
 *
 * p[^:
 *
 * HDIB hDIB        - DIB w肵܂B
 *
 * ߂l:
 *
 * HPALETTE         - pbgw肵܂B
 *
 * :
 *
 * ̊֐͘_pbgpɃ蓖Ă邱Ƃɂ DIB pbg
 * 쐬āADIB ̃J[ e[uF_pbg֓ǂݎ܂͕ۑ
 * āA̘_pbgpbg쐬܂AĂ̌pbg̃n
 * hԂ܂Bɂ DIB ͎gp\ȐFōœKɕ\܂B
 *  (256 Fȏ̏ꍇ͏dvł)
 *
 *
 ************************************************************************/


BOOL WINAPI CreateDIBPalette(HDIB hDIB, CPalette* pPal)
{
	LPLOGPALETTE lpPal;      // _pbgւ̃|C^
	HANDLE hLogPal;          // _pbgւ̃nh
//	HPALETTE hPal = NULL;    // pbgւ̃nh
	int i;                   // [v CfbNX
	WORD wNumColors;         // J[ e[u
	LPSTR lpbi;              // pbNꂽ DIB ւ̃|C^
	LPBITMAPINFO lpbmi;      // BITMAPINFO \ (Win3.0) ւ̃|C^
	LPBITMAPCOREINFO lpbmc;  // BITMAPCOREINFO \ () ւ̃|C^
	BOOL bWinStyleDIB;       // Win3.0 DIB ̔ptO
	BOOL bResult = FALSE;

	/* DIB ւ̃nh̏ꍇ FALSE Ԃ܂B */

	if (hDIB == NULL)
	  return FALSE;

   lpbi = (LPSTR) ::GlobalLock((HGLOBAL) hDIB);

   /* BITMAPINFO (Win 3.0) ւ̃|C^擾܂B */
   lpbmi = (LPBITMAPINFO)lpbi;

   /* BITMAPCOREINFO (old 1.x) ւ̃|C^擾܂B */
   lpbmc = (LPBITMAPCOREINFO)lpbi;

   /* DIB ̐F擾܂B */
   wNumColors = ::DIBNumColors(lpbi);

   if (wNumColors != 0)
   {
		/* _pbgpɃ ubN蓖Ă܂B */
		hLogPal = ::GlobalAlloc(GHND, sizeof(LOGPALETTE)
									+ sizeof(PALETTEENTRY)
									* wNumColors);

		/* \ȃȂꍇA  NULL Ԃ܂B */
		if (hLogPal == 0)
		{
			::GlobalUnlock((HGLOBAL) hDIB);
			return FALSE;
		}

		lpPal = (LPLOGPALETTE) ::GlobalLock((HGLOBAL) hLogPal);

		/* o[Wуpbg̃Ggݒ肵܂B */
		lpPal->palVersion = PALVERSION;
		lpPal->palNumEntries = (WORD)wNumColors;

		/* Win 3.0  DIB? */
		bWinStyleDIB = IS_WIN30_DIB(lpbi);
		for (i = 0; i < (int)wNumColors; i++)
		{
			if (bWinStyleDIB)
			{
				lpPal->palPalEntry[i].peRed = lpbmi->bmiColors[i].rgbRed;
				lpPal->palPalEntry[i].peGreen = lpbmi->bmiColors[i].rgbGreen;
				lpPal->palPalEntry[i].peBlue = lpbmi->bmiColors[i].rgbBlue;
				lpPal->palPalEntry[i].peFlags = 0;
			}
			else
			{
				lpPal->palPalEntry[i].peRed = lpbmc->bmciColors[i].rgbtRed;
				lpPal->palPalEntry[i].peGreen = lpbmc->bmciColors[i].rgbtGreen;
				lpPal->palPalEntry[i].peBlue = lpbmc->bmciColors[i].rgbtBlue;
				lpPal->palPalEntry[i].peFlags = 0;
			}
		}

		/* pbg쐬Aɑ΂nh擾܂B */
		bResult = pPal->CreatePalette(lpPal);
		::GlobalUnlock((HGLOBAL) hLogPal);
		::GlobalFree((HGLOBAL) hLogPal);
	}

	::GlobalUnlock((HGLOBAL) hDIB);

	return bResult;
}

/*************************************************************************
 *
 * FindDIBBits()
 *
 * p[^:
 *
 * LPSTR lpbi       - pbNꂽ DIB  ubNւ̃|C^
 *
 * ߂l:
 *
 * LPSTR            - DIB rbgւ̃|C^
 *
 * :
 *
 * ̊֐ DIB ̃rbg AhXvZ DIB rbgւ̃|C^
 * Ԃ܂B
 *
 ************************************************************************/


LPSTR WINAPI FindDIBBits(LPSTR lpbi)
{
	return (lpbi + *(LPDWORD)lpbi + ::PaletteSize(lpbi));
}


/*************************************************************************
 *
 * DIBWidth()
 *
 * p[^:
 *
 * LPSTR lpbi       - pbNꂽ DIB  ubNւ̃|C^
 *
 * ߂l:
 *
 * DWORD            - DIB ̕
 *
 * :
 *
 * ̊֐ Windows 3.0 X^C DIB ̏ꍇABITMAPINFOHEADER  width
 * tB[h DIB ̕擾邩A܂͂̑̃X^C DIB ̏ꍇ 
 * BITMAPCOREHEADER  width tB[h DIB ̕擾܂B
 *
 ************************************************************************/


DWORD WINAPI DIBWidth(LPSTR lpDIB)
{
	LPBITMAPINFOHEADER lpbmi;  // Win 3.0 X^C DIB ւ̃|C^
	LPBITMAPCOREHEADER lpbmc;  // ̑̃X^C DIB ւ̃|C^

	/* wb_[ւ̃|Cg (Win 3.0 ǂ) */

	lpbmi = (LPBITMAPINFOHEADER)lpDIB;
	lpbmc = (LPBITMAPCOREHEADER)lpDIB;

	/* Win 3.0 DIB  Ȃ DIB ̕Ԃ܂B */
	if (IS_WIN30_DIB(lpDIB))
		return lpbmi->biWidth;
	else  /* ̑̃X^C DIB Ȃ̂ł̕Ԃ܂B */
		return (DWORD)lpbmc->bcWidth;
}


/*************************************************************************
 *
 * DIBHeight()
 *
 * p[^:
 *
 * LPSTR lpbi       - pbNꂽ DIB  ubNւ̃|C^
 *
 * ߂l:
 *
 * DWORD            - DIB ̍
 *
 * :
 * 
 * ̊֐ Windows 3.0 X^C DIB ̏ꍇ́ABITMAPINFOHEADER 
 * height tB[hADIB ̍擾܂A܂͂̑̃X^C
 *  DIB ̏ꍇ́ABITMAPCOREHEADER  DIB ̍擾܂B	
 *
 ************************************************************************/


DWORD WINAPI DIBHeight(LPSTR lpDIB)
{
	LPBITMAPINFOHEADER lpbmi;  // Win 3.0 X^C DIB ւ̃|C^
	LPBITMAPCOREHEADER lpbmc;  // ̑̃X^C DIB ւ̃|C^

	/* wb_[ɑ΂|Cg (^Cv Win 3.0 ǂj */

	lpbmi = (LPBITMAPINFOHEADER)lpDIB;
	lpbmc = (LPBITMAPCOREHEADER)lpDIB;

	/* Win 3.0 DIB ̏ꍇ DIB ̍Ԃ܂B */
	if (IS_WIN30_DIB(lpDIB))
		return lpbmi->biHeight;
	else  /* ̑̃X^C DIB Ȃ̂ŁA̍Ԃ܂B */
		return (DWORD)lpbmc->bcHeight;
}


/*************************************************************************
 *
 * PaletteSize()
 *
 * p[^:
 *
 * LPSTR lpbi       - pbNꂽ DIB  ubNւ̃|C^
 *
 * ߂l:
 *
 * WORD             - DIB ̃J[ pbg̃TCY
 *
 * :
 *
 * ̊֐ RGBQUADiWindows 3.0 X^C DIB)̃TCY܂́ARGBTRIPLE
 * ȋ̃X^C DIB) ̃TCYɂF̑ɂ DIB ̃pbg
 * ۑɕKvȃTCY擾܂B
 * 
 *
 ************************************************************************/


WORD WINAPI PaletteSize(LPSTR lpbi)
{
   /* pbgɕKvȃTCYvZ܂B */
   if (IS_WIN30_DIB (lpbi))
	  return (WORD)(::DIBNumColors(lpbi) * sizeof(RGBQUAD));
   else
	  return (WORD)(::DIBNumColors(lpbi) * sizeof(RGBTRIPLE));
}


/*************************************************************************
 *
 * DIBNumColors()
 *
 * p[^:
 *
 * LPSTR lpbi       - pbNꂽ DIB  ubNւ̃|C^
 *
 * ߂l:
 *
 * WORD             - J[ e[u̐F
 *
 * :
 *
 * ̊֐ DIB (Win3.0 ܂͂̑̃X^CDIBjpɃsNZ
 * rbg邱Ƃɂ DIB ̃J[ e[u̐FvZ܂B
 * sNZ̃rbg 1: colors=2A4: colors=16A8: colors=256A
 * 24̏ꍇ̓J[ e[uɐF͂܂B
 *
 ************************************************************************/


WORD WINAPI DIBNumColors(LPSTR lpbi)
{
	WORD wBitCount;  // DIB rbg JEg

	/*  ꂪ Windows X^C DIB ̏ꍇ́AJ[ e[u̐F
	 *  sNZ̃rbg菭ȂȂ܂B
	 *   ( lpbi->biClrUsed ̒lݒ肳܂)B
	 *  ̏ꍇ́AK؂ȒlԂ܂B
	 */

	if (IS_WIN30_DIB(lpbi))
	{
		DWORD dwClrUsed;

		dwClrUsed = ((LPBITMAPINFOHEADER)lpbi)->biClrUsed;
		if (dwClrUsed != 0)
			return (WORD)dwClrUsed;
	}

	/*  DIB pɃsNZ̃rbgɃJ[ e[u
	 *  FvZ܂B
	 */
	if (IS_WIN30_DIB(lpbi))
		wBitCount = ((LPBITMAPINFOHEADER)lpbi)->biBitCount;
	else
		wBitCount = ((LPBITMAPCOREHEADER)lpbi)->bcBitCount;

	/* sNZ̃rbgɂFԂ܂B*/
	switch (wBitCount)
	{
		case 1:
			return 2;

		case 4:
			return 16;

		case 8:
			return 256;

		default:
			return 0;
	}
}


//////////////////////////////////////////////////////////////////////////
//// Nbv{[h T|[g

//---------------------------------------------------------------------
//
// ֐:   CopyHandle (SDK DibView Tv clipbrd.c )
//
// pr:    w肳ꂽO[o  ubÑRs[쐬܂B
//          V ubNւ̃nhԂ܂B(G[ NULL)
//
//             ShowDIB ̒當ǂ藬pꂽ[`łB
//
// p[^:      h == O[o 𕡐邽߂̃nhB
//
// ߂l:    VO[o  ubNւ̃nhB
//
//---------------------------------------------------------------------

HGLOBAL WINAPI CopyHandle (HGLOBAL h)
{
	if (h == NULL)
		return NULL;

	DWORD dwLen = ::GlobalSize((HGLOBAL) h);
	HGLOBAL hCopy = ::GlobalAlloc(GHND, dwLen);

	if (hCopy != NULL)
	{
		void* lpCopy = ::GlobalLock((HGLOBAL) hCopy);
		void* lp     = ::GlobalLock((HGLOBAL) h);
		memcpy(lpCopy, lp, dwLen);
		::GlobalUnlock(hCopy);
		::GlobalUnlock(h);
	}

	return hCopy;
}
