

#include <Shlobj.h>
#include "stdafx.h"
#include "folder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LPITEMIDLIST    GetItemIDList(LPCTSTR lpszRoot)
{
	if (lpszRoot) {
		LPSHELLFOLDER    pFolder;
		if (::SHGetDesktopFolder(&pFolder)!=NOERROR) return NULL;
		ULONG		chEaten;
		LPITEMIDLIST	pIDL;
		OLECHAR		ochPath[MAX_PATH];
#ifdef _UNICODE
		lstrcpy(ochPath,lpszRoot);
#else
		::MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,lpszRoot,-1,ochPath,MAX_PATH);
#endif
		if (pFolder->ParseDisplayName(NULL,NULL,ochPath,&chEaten,&pIDL,NULL)!=NOERROR)
			pIDL=NULL;
		pFolder->Release();
		return pIDL;
	}
	return NULL;
}

int CALLBACK	BrowseCallback(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM lpData)
{
	TCHAR	szDir[MAX_PATH];
	if (uMsg==BFFM_INITIALIZED) ::SendMessage(hwnd,BFFM_SETSELECTION,FALSE,lpData);
	else if (uMsg==BFFM_SELCHANGED&&::SHGetPathFromIDList((LPITEMIDLIST)lParam,szDir))
		SendMessage(hwnd,BFFM_SETSTATUSTEXT,0,(LPARAM)szDir);
	return 0;
}

bool		GetDirectoryPath(CWnd *pWnd,CString &strDirectory,
			LPCTSTR lpszSelect/*=NULL*/,LPCTSTR lpszRoot/*=NULL*/,LPCTSTR lpszTitle/*=NULL*/)
{
	LPMALLOC	pMalloc;
	bool		rc=false;
	if (::SHGetMalloc(&pMalloc)==NOERROR) {
		LPITEMIDLIST	pIDL=GetItemIDList(lpszRoot);
		LPITEMIDLIST	pSEL=GetItemIDList(lpszSelect);
		TCHAR		buff[MAX_PATH];
		BROWSEINFO	BrowseInfo = {
					(pWnd?pWnd->GetSafeHwnd():NULL),
					pIDL,
					buff,
					lpszTitle,
					BIF_RETURNONLYFSDIRS|BIF_STATUSTEXT,
					BrowseCallback,
					(LPARAM)pSEL,
					0
				};
		LPITEMIDLIST	pIL=SHBrowseForFolder(&BrowseInfo);
		if (pIL) {
			SHGetPathFromIDList(pIL,strDirectory.GetBuffer(MAX_PATH));
			strDirectory.ReleaseBuffer();
			pMalloc->Free(pIL);
			rc=true;
		}
		if (pIDL) pMalloc->Free(pIDL);
		if (pSEL) pMalloc->Free(pSEL);
		pMalloc->Release();
	}
	return rc;
}
 
